#ifndef PARAMETERDUMP_H
#define PARAMETERDUMP_H

#include <QGroupBox>
#include <QGridLayout>
#include <QPushButton>
#include <QLabel>
#include <QSpinBox>
#include <QDoubleSpinBox>

#include <tmpackettoread.h>
#include <TC_types.h>

#include "paulcommoncrc.h"
#include "tcpackettosend.h"

class ParameterDump  : public QWidget
{
    Q_OBJECT
public:
    explicit ParameterDump(QWidget *parent = 0);

    void buildTabParameterDump();
    void buildCOMM();
    void buildNORM();
    void buildBURST();
    void buildSBM1();
    void buildSBM2();
    void buildActions();
    void updateParameterDump(TMPacketToRead *tmPacketToRead);
    void actionsSetEnabled(bool state);

    QGroupBox* groupbox_parameterDump;
    QGroupBox* groupbox_COMM;
    QGroupBox* groupbox_NORM;
    QGroupBox* groupbox_BURST;
    QGroupBox* groupbox_SBM1;
    QGroupBox* groupbox_SBM2;

    QGridLayout* layout_parameterDump;
    QGridLayout* layout_COMM;
    QGridLayout* layout_NORM;
    QGridLayout* layout_BURST;
    QGridLayout* layout_SBM1;
    QGridLayout* layout_SBM2;

    QPushButton* button_loadCommon;
    QPushButton* button_loadNormal;
    QPushButton* button_loadBurst;
    QPushButton* button_loadSBM1;
    QPushButton* button_loadSBM2;
    QPushButton* button_parameterDump;
    //
    QLabel* sy_lfr_bw;
    QLabel* sy_lfr_sp0;
    QLabel* sy_lfr_sp1;
    QLabel* sy_lfr_r0;
    QLabel* sy_lfr_r1;
    //
    QLabel* sy_lfr_n_swf_l;
    QLabel* sy_lfr_n_swf_p;
    QLabel* sy_lfr_n_asm_p;
    QLabel* sy_lfr_n_bp_p0;
    QLabel* sy_lfr_n_bp_p1;
    QLabel* sy_lfr_n_cwf_long_f3;
    //
    QLabel* sy_lfr_b_bp_p0;
    QLabel* sy_lfr_b_bp_p1;
    //
    QLabel* sy_lfr_s1_bp_p0;
    QLabel* sy_lfr_s1_bp_p1;
    //
    QLabel* sy_lfr_s2_bp_p0;
    QLabel* sy_lfr_s2_bp_p1;

    QSpinBox* spinbox_sy_lfr_bw;
    QSpinBox* spinbox_sy_lfr_sp0;
    QSpinBox* spinbox_sy_lfr_sp1;
    QSpinBox* spinbox_sy_lfr_r0;
    QSpinBox* spinbox_sy_lfr_r1;
    //
    QSpinBox* spinbox_sy_lfr_n_swf_l;
    QSpinBox* spinbox_sy_lfr_n_swf_p;
    QSpinBox* spinbox_sy_lfr_n_asm_p;
    QSpinBox* spinbox_sy_lfr_n_bp_p0;
    QSpinBox* spinbox_sy_lfr_n_bp_p1;
    QSpinBox* spinbox_sy_lfr_n_cwf_long_f3;
    //
    QSpinBox* spinbox_sy_lfr_b_bp_p0;
    QSpinBox* spinbox_sy_lfr_b_bp_p1;
    //
    QDoubleSpinBox* spinbox_sy_lfr_s1_bp_p0;
    QSpinBox* spinbox_sy_lfr_s1_bp_p1;
    //
    QSpinBox* spinbox_sy_lfr_s2_bp_p0;
    QSpinBox* spinbox_sy_lfr_s2_bp_p1;

    PaulCommonCRC* paulCommonCRC;

signals:
    unsigned int WriteSPWSig(char *Value, unsigned int count, char targetLogicalAddress, char userApplication);

public slots:
    void sendParameterDump();
    void sendLoadCommon();
    void sendLoadNormal();
    void sendLoadBurst();
    void sendLoadSBM1();
    void sendLoadSBM2();

};

#endif // PARAMETERDUMP_H
